
// Copyright (C) 2012 - 2015 - Michael Baudin
// Copyright (C) 2011 - Digiteo - Michael Baudin
//
// This file must be used under the terms of the GNU Lesser General Public License license :
// http://www.gnu.org/copyleft/lesser.html

//
// gw_distfuncdf.h
//   Header for the DISTFUN CDF gateway.
//
#ifndef __SCI_GW_DISTFUNCDF_H__
#define __SCI_GW_DISTFUNCDF_H__

// Uniform distribution
int sci_distfun_cdfunif(char* fname, unsigned long fname_len);
int sci_distfun_invunif(char* fname, unsigned long fname_len);
int sci_distfun_pdfunif(char* fname, unsigned long fname_len);

// T distribution
int sci_distfun_cdft(char* fname, unsigned long fname_len);
int sci_distfun_invt(char* fname, unsigned long fname_len);
int sci_distfun_pdft(char* fname, unsigned long fname_len);

// Beta distribution
int sci_distfun_cdfbeta(char* fname, unsigned long fname_len);
int sci_distfun_invbeta(char* fname, unsigned long fname_len);
int sci_distfun_pdfbeta(char* fname, unsigned long fname_len);

// Binomial distribution
int sci_distfun_cdfbino(char* fname, unsigned long fname_len);
int sci_distfun_invbino(char* fname, unsigned long fname_len);
int sci_distfun_pdfbino(char* fname, unsigned long fname_len);

// Chi distribution
int sci_distfun_cdfchi2(char* fname, unsigned long fname_len);
int sci_distfun_invchi2(char* fname, unsigned long fname_len);
int sci_distfun_pdfchi2(char* fname, unsigned long fname_len);
int sci_distfun_cdfncx2(char* fname, unsigned long fname_len);

// F distribution
int sci_distfun_cdff(char* fname, unsigned long fname_len);
int sci_distfun_invf(char* fname, unsigned long fname_len);
int sci_distfun_pdff(char* fname, unsigned long fname_len);

// Gamma distribution
int sci_distfun_cdfgam(char* fname, unsigned long fname_len);
int sci_distfun_invgam(char* fname, unsigned long fname_len);
int sci_distfun_pdfgam(char* fname, unsigned long fname_len);

// Normale distribution
int sci_distfun_cdfnorm(char* fname, unsigned long fname_len);
int sci_distfun_invnorm(char* fname, unsigned long fname_len);
int sci_distfun_pdfnorm(char* fname, unsigned long fname_len);

// Poisson distribution
int sci_distfun_cdfpoiss(char* fname, unsigned long fname_len);
int sci_distfun_invpoiss(char* fname, unsigned long fname_len);
int sci_distfun_pdfpoiss(char* fname, unsigned long fname_len);

// Hypergeometric distribution
int sci_distfun_cdfhyge(char* fname, unsigned long fname_len);
int sci_distfun_invhyge(char* fname, unsigned long fname_len);
int sci_distfun_pdfhyge(char* fname, unsigned long fname_len);

// Exponential distribution
int sci_distfun_pdfexp(char* fname, unsigned long fname_len);
int sci_distfun_cdfexp(char* fname, unsigned long fname_len);
int sci_distfun_invexp(char* fname, unsigned long fname_len);

// Geometric distribution
int sci_distfun_pdfgeo(char* fname, unsigned long fname_len);
int sci_distfun_cdfgeo(char* fname, unsigned long fname_len);
int sci_distfun_invgeo(char* fname, unsigned long fname_len);

// Log-Normale distribution
int sci_distfun_pdflogn(char* fname, unsigned long fname_len);
int sci_distfun_cdflogn(char* fname, unsigned long fname_len);
int sci_distfun_invlogn(char* fname, unsigned long fname_len);

// Non-Central Chi distribution
int sci_distfun_invchn(char* fname, unsigned long fname_len);
int sci_distfun_cdfchn(char* fname, unsigned long fname_len);

// Non-Central F distribution
int sci_distfun_invfnc(char* fname, unsigned long fname_len);
int sci_distfun_cdfncf(char* fname, unsigned long fname_len);

// Negative Binomiale distribution
int sci_distfun_invnbn(char* fname, unsigned long fname_len);
int sci_distfun_cdfnbn(char* fname, unsigned long fname_len);
int sci_distfun_pdfnbn(char* fname, unsigned long fname_len);

// Noncentral T distribution
int sci_distfun_cdfnct(char* fname, unsigned long fname_len);
int sci_distfun_invnct(char* fname, unsigned long fname_len);
int sci_distfun_pdfnct(char* fname, unsigned long fname_len);

// Multivariate Normal
int sci_distfun_pdfmvn(char* fname, unsigned long fname_len);

// Weibull distribution
int sci_distfun_cdfwbl(char* fname, unsigned long fname_len);
int sci_distfun_invwbl(char* fname, unsigned long fname_len);
int sci_distfun_pdfwbl(char* fname, unsigned long fname_len);

// Extreme Value distribution
int sci_distfun_cdfev(char* fname, unsigned long fname_len);
int sci_distfun_invev(char* fname, unsigned long fname_len);
int sci_distfun_pdfev(char* fname, unsigned long fname_len);

// Regularized Incomplete Gamma Function
int sci_distfun_incgamma(char* fname, unsigned long fname_len);

// Kolmogorov Smirnov Distribution
int sci_distfun_cdfks(char* fname, unsigned long fname_len);
int sci_distfun_invks(char* fname, unsigned long fname_len);
int sci_distfun_pdfks(char* fname, unsigned long fname_len);

#endif /* __SCI_GW_DISTFUNCDF_H__ */
